import { NodeInterface, BlockPlugin, PluginOptions } from '@aomao/engine';
import './index.css';
export interface QuoteOptions extends PluginOptions {
    hotkey?: string | Array<string>;
    markdown?: boolean;
}
export default class<T extends QuoteOptions> extends BlockPlugin<T> {
    tagName: string;
    canMerge: boolean;
    static get pluginName(): string;
    init(): void;
    execute(): void;
    queryState(): boolean | undefined;
    hotkey(): string | string[];
    markdown(event: KeyboardEvent, text: string, block: NodeInterface): false | undefined;
    pasteEach(node: NodeInterface): void;
    checkMarkdown(node: NodeInterface): {
        reg: RegExp;
        match: RegExpExecArray | null;
    } | undefined;
    pasteMarkdown(node: NodeInterface): void;
    onBackspace(event: KeyboardEvent): false | undefined;
    onEnter(event: KeyboardEvent): false | undefined;
    parseHtml(root: NodeInterface): void;
    pasteHtml(node: NodeInterface): boolean | undefined;
}
