import _classCallCheck from '@babel/runtime/helpers/esm/classCallCheck';
import _createClass from '@babel/runtime/helpers/esm/createClass';
import _get from '@babel/runtime/helpers/esm/get';
import _getPrototypeOf from '@babel/runtime/helpers/esm/getPrototypeOf';
import _inherits from '@babel/runtime/helpers/esm/inherits';
import _createSuper from '@babel/runtime/helpers/esm/createSuper';
import { isEngine, $, BlockPlugin } from '@aomao/engine';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".am-engine blockquote, .am-engine-view blockquote {\r\n    margin: 5px 0 5px 0;\r\n    border-left: 3px solid #eee;\r\n    color: #8C8C8C;\r\n}\r\n\r\n.am-engine blockquote + blockquote, .am-engine-view blockquote + blockquote {\r\n    margin-top: -5px;\r\n}\r\n\r\n.am-engine blockquote > *, .am-engine-view blockquote > * {\r\n    margin-left: 14px;\r\n    color: #8C8C8C;\r\n}\r\n\r\n.am-engine blockquote *, .am-engine-view blockquote * {\r\n    color: #8C8C8C;\r\n}\r\n\r\n.am-engine blockquote a, .am-engine blockquote a:hover, .am-engine-view blockquote a, .am-engine-view blockquote a:hover {\r\n  color: #1890ff !important;\r\n}";
styleInject(css_248z);

var _default = /*#__PURE__*/function (_BlockPlugin) {
  _inherits(_default, _BlockPlugin);

  var _super = _createSuper(_default);

  function _default() {
    var _this;

    _classCallCheck(this, _default);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.tagName = 'blockquote';
    _this.canMerge = true;
    return _this;
  }

  _createClass(_default, [{
    key: "init",
    value: function init() {
      var _this2 = this;

      _get(_getPrototypeOf(_default.prototype), "init", this).call(this);

      this.editor.schema.addAllowIn(this.tagName);
      this.editor.on('parse:html', function (node) {
        return _this2.parseHtml(node);
      });

      if (isEngine(this.editor)) {
        this.editor.on('paste:each', function (child) {
          return _this2.pasteHtml(child);
        });
        this.editor.on('keydown:backspace', function (event) {
          return _this2.onBackspace(event);
        });
        this.editor.on('keydown:enter', function (event) {
          return _this2.onEnter(event);
        });
        this.editor.on('paste:markdown', function (child) {
          return _this2.pasteMarkdown(child);
        });
        this.editor.on('paste:each', function (child) {
          return _this2.pasteEach(child);
        });
        this.editor.on('paste:markdown-check', function (child) {
          var _this2$checkMarkdown;

          return !((_this2$checkMarkdown = _this2.checkMarkdown(child)) === null || _this2$checkMarkdown === void 0 ? void 0 : _this2$checkMarkdown.match);
        });
      }
    }
  }, {
    key: "execute",
    value: function execute() {
      if (!isEngine(this.editor)) return;
      var _this$editor = this.editor,
          change = _this$editor.change,
          block = _this$editor.block,
          node = _this$editor.node;

      if (!this.queryState()) {
        block.wrap("<".concat(this.tagName, " />"));
      } else {
        var range = change.range.get();
        var blockquote = change.blocks[0].closest(this.tagName);
        var selection = range.createSelection();
        node.unwrap(blockquote);
        selection.move();
        change.range.select(range);
        return;
      }
    }
  }, {
    key: "queryState",
    value: function queryState() {
      if (!isEngine(this.editor)) return;
      var change = this.editor.change;
      var blocks = change.blocks;

      if (blocks.length === 0) {
        return false;
      }

      var blockquote = blocks[0].closest(this.tagName);
      return this.isSelf(blockquote);
    }
  }, {
    key: "hotkey",
    value: function hotkey() {
      return this.options.hotkey || 'mod+shift+u';
    } //设置markdown

  }, {
    key: "markdown",
    value: function markdown(event, text, block) {
      if (this.options.markdown === false || !isEngine(this.editor)) return;
      var _this$editor2 = this.editor,
          node = _this$editor2.node,
          command = _this$editor2.command;
      var blockApi = this.editor.block;
      var plugin = blockApi.findPlugin(block); // fix: 列表、引用等 markdown 快捷方式不应该在标题内生效

      if (block.name !== 'p' || plugin && plugin.constructor.pluginName === 'heading') {
        return;
      }

      if (['>'].indexOf(text) < 0) return;
      event.preventDefault();
      blockApi.removeLeftText(block);

      if (node.isEmpty(block)) {
        block.empty();
        block.append('<br />');
      }

      command.execute(this.constructor.pluginName);
      return false;
    }
  }, {
    key: "pasteEach",
    value: function pasteEach(node) {
      var _node$parent;

      if (node.isText() && ((_node$parent = node.parent()) === null || _node$parent === void 0 ? void 0 : _node$parent.name) === this.tagName) {
        this.editor.node.wrap(node, $('<p></p>'));
      }
    }
  }, {
    key: "checkMarkdown",
    value: function checkMarkdown(node) {
      if (!isEngine(this.editor) || !this.markdown || !node.isText()) return;
      var text = node.text();
      if (!text) return;
      var reg = /(^|\r\n|\n)([>]{1,})/;
      var match = reg.exec(text);
      return {
        reg: reg,
        match: match
      };
    }
  }, {
    key: "pasteMarkdown",
    value: function pasteMarkdown(node) {
      var _this3 = this;

      var result = this.checkMarkdown(node);
      if (!result) return;
      var reg = result.reg,
          match = result.match;
      if (!match) return;
      var text = node.text();
      var newText = '';
      var rows = text.split(/\n|\r\n/);
      var nodes = [];
      rows.forEach(function (row) {
        var match = /^([>]{1,})/.exec(row);

        if (match) {
          var _childNodes$eq;

          var codeLength = match[1].length;
          var content = row.substr(/^\s+/.test(row.substr(codeLength)) ? codeLength + 1 : codeLength);
          var container = $('<div></div>');
          container.html(content);
          var childNodes = container.children();

          if (childNodes.length > 1 || childNodes.length === 1 && !_this3.editor.node.isBlock(childNodes[0]) && !((_childNodes$eq = childNodes.eq(0)) === null || _childNodes$eq === void 0 ? void 0 : _childNodes$eq.isBlockCard())) {
            nodes.push("<p>".concat(content, "</p>"));
          } else {
            nodes.push(content);
          }
        } else if (nodes.length > 0) {
          newText += "<".concat(_this3.tagName, ">").concat(nodes.join(''), "</").concat(_this3.tagName, ">") + '\n' + row + '\n';
          nodes = [];
        } else {
          newText += row + '\n';
        }
      });

      if (nodes.length > 0) {
        newText += "<".concat(this.tagName, ">").concat(nodes.join(''), "</").concat(this.tagName, ">") + '\n';
      }

      node.text(newText);
    }
  }, {
    key: "onBackspace",
    value: function onBackspace(event) {
      if (!isEngine(this.editor)) return;
      var _this$editor3 = this.editor,
          change = _this$editor3.change,
          node = _this$editor3.node;
      var range = change.range.get();
      var blockApi = this.editor.block;
      var inEnd = blockApi.isLastOffset(range, 'end');

      if (inEnd && !range.collapsed) {
        var startBlock = blockApi.closest(range.startNode);
        var endBlock = blockApi.closest(range.endNode);
        var startParentBlock = startBlock.parent();
        var endParentBlock = endBlock.parent();

        if (startParentBlock && endParentBlock && endParentBlock.name === 'blockquote' && !startParentBlock.equal(endParentBlock)) {
          endParentBlock.remove();
          return;
        }
      }

      var inFirst = blockApi.isFirstOffset(range, 'start');
      if (!inFirst) return;
      var block = blockApi.closest(range.startNode);
      var parentBlock = block.parent();

      if (parentBlock && parentBlock.name === 'blockquote' && node.isBlock(block)) {
        event.preventDefault();

        if (block.prevElement()) {
          change.mergeAfterDelete(block);
        } else {
          if (node.isEmpty(parentBlock)) {
            var newBlock = $('<p><br/></p>');
            parentBlock.replaceWith(newBlock);
            range.select(newBlock, true).collapse(false);
            change.apply(range);
          } else {
            blockApi.unwrap('<blockquote />');
          }
        }

        return false;
      }

      return;
    }
  }, {
    key: "onEnter",
    value: function onEnter(event) {
      if (!isEngine(this.editor)) return;
      var change = this.editor.change;
      var blockApi = this.editor.block;
      var range = change.range.get(); // 选区选中最后的节点

      var block = blockApi.closest(range.endNode);
      var parent = block.parent();

      if ((parent === null || parent === void 0 ? void 0 : parent.name) === this.tagName && 'p' === block.name && block.nextElement()) {
        event.preventDefault();
        blockApi.insertOrSplit(range, block);
        return false;
      }

      return;
    }
  }, {
    key: "parseHtml",
    value: function parseHtml(root) {
      root.find('blockquote').css({
        'margin-top': '5px',
        'margin-bottom': '5px',
        'padding-left': '1em',
        'margin-left': '0px',
        'border-left': '3px solid #eee',
        opacity: '0.6'
      });
    }
  }, {
    key: "pasteHtml",
    value: function pasteHtml(node) {
      if (!isEngine(this.editor)) return;

      if (node.name === this.tagName) {
        node.css('padding-left', '');
        node.css('text-indent', '');
        return false;
      }

      return true;
    }
  }], [{
    key: "pluginName",
    get: function get() {
      return 'quote';
    }
  }]);

  return _default;
}(BlockPlugin);

export default _default;
